/*! ********************************************
 * IGrayBoxModule.java
 * Copyright 2019 masahiro takamoto (MotChan)
 * Distributed under the MIT license. 
 * see -> sora/license.txt
 ******************************************** */
package sora.graybox;

public interface IGrayBoxModule
{
// host ---	
	public void updateSampleRate(float sampleRate);
	public void updateAudioChannels(int ch);
	public void updateProcessBlockSize(int size);
// module ---	
	public void resetModule();
	public void initiModule();
	public void connectModule(GrayBox host);
	public void disconnectModule();
	public void updateBypassStatus(boolean bypass);
// process ---
	public void startProcess();
	public void stopProcess();
	public void suspendProcess();
	public void resumeProcess();
	public void process(ProcessData procData);
}