/*! ********************************************
 * VoicePart.java
 * Copyright 2019 masahiro takamoto (MotChan)
 * Distributed under the MIT license. 
 * see -> sora/license.txt
 ******************************************** */
package sora.graybox.synth;

public class VoicePart
{
	// status
	int mode        = 0;
	int defaultMode = 0;
	// Parameter
	public int programChange = 0;
	public int chPressure    = 0;
	public int pitchBend     = 8192;
	public int[] ccValues    = new int[120];
	// Extra
	public int bendSens = 2;
	public int extVal0  = 0;
	public int extVal1  = 0;
	/*
	- RPN,NRPN -
		         [FE DCBA987 6543210]
		value -> [dc bbbbbbb aaaaaaa]
		a = RPN,NRPN (LSB)
		b = RPN,NRPN (MSB)
		c = Flag (Received LSB)
		d = Flag (Received MSB)
			
		paramNumber -> RPN[0-127], NRPN[128-255], nullRPN[256]
		value <= 100h [100h : null RPN] 
	*/
	int rpn         = 0;
	int nrpn        = 0;
	int paramNumber = 0x100;
	
	public void reset()
	{
		programChange = 0;
		chPressure    = 0;
		pitchBend     = 8192;
		bendSens      = 2;
		
		for (int i = 0; i < 120; i++) ccValues[i] = 0;
		ccValues[ 1] = 0;
		ccValues[ 7] = 100;
		ccValues[10] = 64;
		ccValues[11] = 127;
		
		rpn         = 0;
		nrpn        = 0;
		paramNumber = 0x100;
		
		extVal0 = 0;
		extVal1 = 0;
	}
	void resetAllControlle()
	{
		chPressure   = 0;
		pitchBend    = 8192;
		
		ccValues[ 1] = 0;
		ccValues[11] = 127;
		
		rpn         = 0;
		nrpn        = 0;
		paramNumber = 0x100;
	}
	void resetRPNControlle()
	{
		rpn         = 0;
		nrpn        = 0;
		paramNumber = 0x100;
	}
//constructor
	public VoicePart(){ this(0); }
	public VoicePart(int defaultMode)
	{
		this.defaultMode = defaultMode;
		mode = defaultMode;
		reset();
	}
}